/*************************************************************************
*	"ZNSPLAY"
*************************************************************************/


#include	<stdio.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	<string.h>
#include	<time.h>
#ifdef	__HIGHC__
#	include	<heap.cf>
#endif

#include	<egb.h>
#include	<mos.h>
#include	<snd.h>
#include	<xld.h>
#include	<sidework.h>
#include	<loader.h>

#include	"znsplay.h"
#include	"../DLL/BGM/midi.h"

#include	<setint.h>
#include	<doscons.h>
#include	<spgetopt.h>
#include	<fdl.h>
#include	<FDL/fdlcol.h>
#include	<dta.h>
#include	<dtaname.h>

extern int		SideWorkMenu(void);

int						FlagQuickRet = FALSE;
static CONST char		RECODENAME_MAINARG[]   = DTA_RECODENAME_MAINARG;
static CONST char		RECODENAME_STARTPATH[] = DTA_RECODENAME_STARTPATH;
DTACTRL_T			   *DtaCtrl = NULL;

static	PLT_RGB	PltDat[16] =
{
	/* G R  B								*/
	{ 0, 0, 0},	/* C_BALCK					*/
	{ 0, 0, 0},	/* C_BLUE or C_THROUGH		*/
	{ 7, 7, 8},	/* C_RED					*/
	{12,12,13},	/* C_MAGENTA				*/
	{ 6, 5, 7},	/* C_GREEN					*/
	{ 8, 7, 9},	/* C_CYAN					*/
	{10, 9,11},	/* C_YELLOW					*/
	{11,11,12},	/* C_WHITE					*/

	{ 5, 5, 6},	/* C_HBALCK					*/
	{ 0, 0,11},	/* C_HBLUE					*/
	{ 0,11, 0},	/* C_HRED					*/
	{ 0,11,11},	/* C_HMAGENTA				*/
	{11, 0, 0},	/* C_HGEEN					*/
	{11, 0,11},	/* C_HCYAN					*/
	{11,11, 0},	/* C_HYELLOW				*/
	{14,14,15}	/* C_HWHITE					*/
};


POINT		DisplayStartPara[4] = 
{
	{0,0},		/* ʂ̕\Jn̐ݒ	*/
	{0,0},		/* zʒ̈ړ			*/
	{2,2},		/* ʂ̊g				*/
	{320,240},	/* \ʂ̑傫			*/
};

void	page1_palette(void)
{
	DSP_writePage(1);
	DSP_setPlt(PltDat);
}

void	ZNS_displayStart( int mode, int x, int y )
{
	DisplayStartPara[mode].x = x;
	DisplayStartPara[mode].y = y;
	EGB_displayStart(EgbPtr, mode, DisplayStartPara[mode].x,
	                               DisplayStartPara[mode].y );
}

#if	0
void	reinit(void)
{
	int		page;

	{
		int		i;
		page = 0;
		for ( i = 0; i < 4; ++i )
		{
			EGB_displayStart(EgbPtr, i, DisplayStartPara[i].x,
			                            DisplayStartPara[i].y );
		}
	}
	{
		page = 1;
		EGB_writePage(EgbPtr, page );
		EGB_displayStart(EgbPtr, 1, DspCtrl.scinf[page].dspstart.x,
		                            DspCtrl.scinf[page].dspstart.y );
		EGB_displayStart(EgbPtr, 3, DspCtrl.scinf[page].sc.x2+1,
		                            DspCtrl.scinf[page].sc.y2+1 );
	}

	MOS_setControl(0x7F);
	MOS_resolution(0,DspCtrl.page0);
	MOS_resolution(1,DspCtrl.page1);
	MOS_writePage(MosInf.page);
	MOS_curType( 81 );
	MosInf.move = DspCtrl.scinf[MosInf.page].sc;
	MOS_moveArea( MosInf.move.x1, MosInf.move.y1,
	              MosInf.move.x2, MosInf.move.y2 );

	page1_palette();
}
#endif

/*************************************************************************
*	VXe
*************************************************************************/
static int		init( int *argc, char **argv[], int _argc, char **_argv )
{
#ifdef	__HIGHC__
	/* 擾pݒ	*/
	Init_allocated_storage = 0;
#endif

	*argc = _argc;
	*argv = _argv;
	if ( DTA_isAtPcl() )
	{
		/* qvZXN	*/
		DTARECODE_T	*recode_arg = NULL, *recode_startpath = NULL;
		char		*args = "ZNSPLAY";
		char		*startpath = NULL;

		if ( (DtaCtrl = DTA_openCheck()) != NULL )
		{
			if ( (recode_arg = DTA_openRecode( DtaCtrl, RECODENAME_MAINARG)) != NULL )
			{	/* p[^̎w肠	*/
				args = recode_arg->ptr;
			}
			if ( (recode_startpath = DTA_openRecode( DtaCtrl, RECODENAME_STARTPATH)) != NULL )
			{	/* p[^̎w肠	*/
				startpath = recode_startpath->ptr;
			}
		}
		if ( (*argc = FS_argSet( args, argv )) < 1 )
			return (ERR);
		if ( startpath )
			*argv[0] = startpath;
	}

	set_ctrl_c();
	set24h();

	if ( SndPtr == NULL )
	{
		if ( (SndPtr = calloc(16384,1)) == NULL )
		{
			reset24h();
			return (ERR);
		}
		SND_init( SndPtr );
	}

	{
		DSP_sysInit(NULL);

		EGB_displayPage(EgbPtr,0,0);
		EGB_resolution(EgbPtr,0,ZNS_RESOLUSION);	/* ʃ[hݒ	*/
		EGB_displayStart(EgbPtr,2,2,2);
		EGB_displayStart(EgbPtr,3,320,240);
		EGB_displayPage(EgbPtr,1,3);

		DspCtrl.page0              = ZNS_RESOLUSION;
		DspCtrl.scinf[0].md        = ZNS_RESOLUSION;

		DspCtrl.scinf[0].fr.x1      = 0;
		DspCtrl.scinf[0].fr.y1      = 0;
		DspCtrl.scinf[0].fr.x2      = 511;
		DspCtrl.scinf[0].fr.y2      = 255;
		DspCtrl.scinf[0].sc.x1      = 0;
		DspCtrl.scinf[0].sc.y1      = 0;
		DspCtrl.scinf[0].sc.x2      = 319;
		DspCtrl.scinf[0].sc.y2      = 239;
		DspCtrl.scinf[0].view.x1    = 0;
		DspCtrl.scinf[0].view.y1    = 0;
		DspCtrl.scinf[0].view.x2    = 319;
		DspCtrl.scinf[0].view.y2    = 239;
		DspCtrl.scinf[0].dlgArea.x1 = 2;
		DspCtrl.scinf[0].dlgArea.y1 = 14;
		DspCtrl.scinf[0].dlgArea.x2 = 319-2;
		DspCtrl.scinf[0].dlgArea.y2 = 239-10;
		MosInf.scrollPage = 0xFF;		/* XN[Ȃ	*/
	}

	DSP_set_defFnt( FNTYPE_USR1 );
	GetFnt12Ptr(0);				/* ank font 12 ݒ		*/
	KBF_sysInit();				/* L[{[hVXe	*/
	KBF_kan_off();				/* Ȋϊ֎~			*/
	FDL_sysInit();				/* t@C_CAO		*/
	sdk_control(0);				/* TCh[NN֎~		*/

	/* DLL VXe	*/
	_XLD_init(NULL);
	_XLD_setMemFunc( malloc, free );
	{
		char	tmp[256];
		int		len;

		FS_setStartPath( tmp, *argv[0] );
		if ( (len = strlen(tmp)) > 0 )
			tmp[--len] = '\0';
		_XLD_setLinkPath( tmp );
	}
	_XLD_lockLib( MID_playStatFlag );

	/* MIDI BGM VXe	*/
	MID_sysInit();

	/* pbgݒ	*/
	DSP_writePage(1);
	DSP_setPlt(PltDat);

	/*	^Cg\	*/
	DSP_writePage(1);
	DSP_title( _ZNSPLAY_, MAIN_VER, C_HWHITE, C_WHITE, C_MBLACK, C_HBLACK );

	/* t@C_CAO	*/
	FdlDefColTbl[0] = C_DLGBASE;
	Fdl_set_doscall( DOScons_open, DOScons_close, system);
	Fdl_set_sidework( SideWorkMenu );
	FdlSetWildCardList( ZNS_WILD_ALL );
	FdlSetWildCardList( ZNS_WILD_MOV );
/*	FdlSetWildCardList( ZNS_WILD_V00 );	*/
	FdlSetWildCardList( ZNS_WILD_V02 );

	return (NORMAL);
}

static void	term(void)
{
	EGB_writePage(EgbPtr,0);
	EGB_color(EgbPtr,1,0);
	EGB_clearScreen(EgbPtr);

	DSP_writePage(1);
	HVboxf(DspCtrl.scinf[1].sc.x1, DspCtrl.scinf[1].sc.y1+DspTitYs,
	       DspCtrl.scinf[1].sc.x2, DspCtrl.scinf[1].sc.y2-16,0);

	MID_sysEnd();
	FDL_sysEnd();
	KBF_sysEnd();
	DSP_sysEnd();

	if ( SndPtr )
	{
		SND_end();
		free(SndPtr);
		SndPtr = NULL;
	}

	reset24h();
}

static	void	help(void)
{
	static CONST char	help_msg[] = "\
     usage : znsplay [<option>] [<filename>]    \n\
     <option>                                   \n\
       -wait <n>    ... wait time (n:0`99)     \n\
       -display <n> ... display mode (n:1`4)   \n\
       -disk        ... disk play mode          \n\
       -memory      ... memory play mode        \n\
       -chkPort <right/left/both>               \n\
                    ... pause & stop check port \
";

	DSP_writePage(1);
	DLG_tmpMsgBox ( DLGPOS_CENTER_OF_SCN, DLGPOS_CENTER_OF_SCN,
	    DspCtrl.black, C_DLGBASE, COLMIX(C_INFO,C_GRAY),
	    "gUGOKUZANSUh movie data player  %s ver.%s\n\n%s",
	    _ZNSPLAY_, MAIN_VER, help_msg );

}

static int		errFunc( CONST char *s )
{
	/* return (-1) f               */
	/* return (1)  G[͖Ēf */
	/* return (0)  G[͖         */

	return (0);
}

/*************************************************************************
*	IvVp[^̉́^ݒ
*************************************************************************/

static int		set_option( int argc, char **argv )
{
	int						ret = NORMAL;
	static int				helpVar    = 0;
	static GOP_DIGIT_T		waitPar    = { 0, 0, 99 };
	static GOP_DIGIT_T		displayPar = { 1, 1, 4 };
	static int				memoryVar  = 0;
	static int				diskVar    = 0;
	extern int				ZnsSwPort;
	static GOP_SELECT_OBJ_T	ZnsSwPortObj[3] =
	{
		{1,"left" },
		{2,"right"},
		{3,"both" },
	};
	static	GOP_SELECT_T	ZnsSwPortPar = {3, ZnsSwPortObj};

	static	GOPKEY_T	GetoptKey[] = 
	{
		{ GOP_TYP_FLAG  , "?"             , GOP_VAR_INT , &helpVar             , NULL         },
		{ GOP_TYP_DIGIT , "wait"          , GOP_VAR_INT , &ZnsMove.wait        , &waitPar     },
		{ GOP_TYP_DIGIT , "display"       , GOP_VAR_INT , &ZnsMove.expand      , &displayPar  },
		{ GOP_TYP_FLAG  , "memory"        , GOP_VAR_INT , &memoryVar           , NULL         },
		{ GOP_TYP_FLAG  , "disk"          , GOP_VAR_INT , &diskVar             , NULL         },
		{ GOP_TYP_SELECT, "chkPort"       , GOP_VAR_INT , &ZnsSwPort           , &ZnsSwPortPar},
		{ GOP_TYP_FLAG  , "quickret"      , GOP_VAR_INT , &FlagQuickRet        , NULL         },
		{ -1            ,  NULL           , 0           , NULL                 , NULL         },
	};
	GOP_T	gop = {GOP_MODE_NORMAL,"-/",GetoptKey,errFunc,0,NULL};

	if ( argc < 2 )
		return (NORMAL);

	if ( GOP_decode(&gop,argc-1,&argv[1]) == NORMAL )
	{
		if ( helpVar )
			help();
		if ( memoryVar )
			ZnsMove.mode = ZNS_MODE_MEMORY;
		else if ( diskVar )
			ZnsMove.mode = ZNS_MODE_DISK;

		{
			GOPETC_T	*etc = gop.etc;

			while ( etc )
			{
				if ( etc->s[0] )
				{
					strcpy( ZnsMove.filename, etc->s );
					if ( FS_isFileExist(ZnsMove.filename) == FS_EXIST_FILE )
					{
						zns_dsp_info();
						zns_play( &ZnsMove );
					}
				}
				etc = etc->next;
			}
			if ( FlagQuickRet )
				ret = 1;
		}
	}
	GOP_free( &gop );

	return (ret);
}

void	main(int _argc, char *_argv[])
{
	int			ret;
	int 		argc;
	char		**argv;

	if ( init(&argc,&argv,_argc,_argv) )
	{
		ret = 1;
	} else
	{
		if ( argc > 1 && set_option(argc,argv) )
		{
			ret = 1;
		} else
		{
			zns_main();
			ret = 0;
		}
		term();
	}

	pcl_exit(0);
	exit(ret);
}
